// Monologio con Trillo sonoro dell'ora  version 3.3  del 31/12/2022 by F.Lucesio
// Orologio ultra minimalista ad un solo led 
// visualizza l'ora ad intervalli fissi lampeggiando 
// per N cicli ogni cifra per 3 cifre : H,M,m
// la cifra 0 comporta una durata Iz del led acceso
// la rimessa orologio avviene tramite singolo tasto
// Si tiene premuto e si rilascia dopo un paio di secondi
// quindi si preme simulando il lampeggio del led per visualizzare l'ora

// definizione variabili ----------------

// tempo
byte h=12; // mezzogiorno
byte m=0;
byte mprec=-1;
byte s;
byte o;

// temporizzatori (valori in millisecondi)
// ciclo generale (ogni 20 secondi)
long int Ig=20000;
// intervallo tra le cifre
int Ic=2000;
// durata lampo led
int Il=100;
// pausa tra lampi led
int Ip=300;
// durata lampo per Zero
int Iz=1000;
// durata pulsante premuto per rimessa: si attiva se maggiore di
int Ib=1000;



// varie
byte cosarim = 0; // punta a : 1 = ore  2 = decine min  3 = unita min  0 = flag rimessa
long int Tempo;
long int Tp;
byte notte = 0;  // per controllo fotocellula



// digital I/O
const byte pin_LED =3;
const byte pin_LEDN =6;
const byte speakerPin = 12;
const byte photo = A3;    // ingresso fotocellula


// pulsante
const int buttonPin = 10;  
byte buttonState = 0;     // stato pulsante
byte lastButtonState = 0; // stato precedente
int startPressed = 0;    // pulsante premuto
int endPressed = 0;      // pulsante rilasciato
int holdTime = 0;        // per timer pulsante on
int idleTime = 0;        // per timer pulsante off

void setup()
{


 pinMode(photo, INPUT);
  
 Tempo=millis();  //inizializza il timer
 // inizializza pulsante 
 pinMode(pin_LED, OUTPUT);
 pinMode(pin_LEDN, OUTPUT);
 pinMode(buttonPin, INPUT);
 
 pinMode(speakerPin, OUTPUT);
 playTone(1000,3000);

 }


void loop()
{
 
// guarda se deve indicare l'ora

Tp=millis()-Tempo;


if (Tp >= Ig and cosarim == 0)
// if (1==0)
{
   Tempo=millis();


// fotocellula disabilitata
/*
if (analogRead(photo) > 900)
        notte=3;
if (analogRead(photo) < 800)
        notte=0;
*/

// notte alternativa

if (h > 21 || (h >= 0 && h < 9))
      notte=3;
else
      notte=0;


// incrementa orologio
   s=s+Ig/1000;
   if(s>=60){
    s=0;
    m=m+1;
   }
   if(m==60)
   {
    m=0;
    h=h+1;
   }
   if(h==24)
   {
    h=0;
   }
 
   // display ora 

   // ore 
   if(h >12)
     o = h-12;
   else 
     o=h;
   lampeggia(o);
   delay(Ic);

   // decine minuti
   lampeggia(int(m/10));
   delay(Ic);

  // unita   minuti
   lampeggia(m - int(m/10)*10);
  
  
  // guarda se deve suonare
  if ( m == 0 && m != mprec )
  {
  mprec=m;
  if(h >12)
     o = h-12;
  else 
     o=h;
  trilla(o);
  }

if (m !=0)
   mprec = m;
 
 }

// Controlla se deve attivare la rimessa monorogio
// Si attiva quando il pulsante rimane premuto almeno per Ib millisec e rilasciato

  buttonState = digitalRead(buttonPin); 

  if (buttonState != lastButtonState) { 

 // Pulsante premuto
  if (buttonState == HIGH) {
      startPressed = millis();
      idleTime = startPressed - endPressed;

  // pulsante rilasciato 
  } else {
      endPressed = millis();
      holdTime = endPressed - startPressed;
      if (holdTime >= Ib) {
         // azzera l'ora
         h=0;          
         m=0;
         s=10;  // per rimettere con una certa precisione si aggiunge il tempo di rimessa
         rimetti();
         if(h==0)
           h=12;
       }
    }
  }

  lastButtonState = buttonState;        // save state for next loop

}
    

// funzione rimetti
// consente di rimetter l'ora dell'orologio 
// fornendo il numero di impulsi nella sequenza esattamente 
// come vengono visualizzati a led: ore, decine min, unita min
// il led guida la rimessa lampeggiando in negativo 
// ad ogni pressione del tasto con pausa lunga 1 sec. fra le cifre


void rimetti() {
 double Tpause = 2000; //pausa per stabilire il passaggio ad altra cifra
 double  Tprec;
 int currentButtonState;
 int previousButtonState;
do {

 Tprec=millis();
 do {
    previousButtonState = currentButtonState;
    currentButtonState = digitalRead(buttonPin);
    digitalWrite(pin_LEDN,HIGH);
    if (previousButtonState == HIGH and currentButtonState == LOW) { // assumes LOW = pressed
      Tprec = millis();
      switch (cosarim) {
       case 1:
         h++;
        if ( h > 23) {
          h=0;
        }
        break;
       case 2:
         m=m+10;
        if (m > 59) {
          m=50;
        }
        break;
       default:
         m=m+1;
        if (m > 59) {
          m=59;
        }
       break;
      }
      digitalWrite(pin_LEDN,LOW);
      delay(300);
      digitalWrite(pin_LEDN,HIGH); 
    }

 } while (millis()-Tprec < Tpause);

    digitalWrite(pin_LEDN,LOW);
    delay(1000); 
    cosarim++;
 } while (cosarim <4);

digitalWrite(pin_LEDN,LOW);
cosarim=0;
}

 

// funzione lampeggia 

void lampeggia(int n){
int i;
if (n==0)
{
  // zero equivale ad un lampeggio lungo Iz
  digitalWrite(pin_LED+notte,HIGH);
  delay(Iz);
  digitalWrite(pin_LED+notte,LOW);
}
else
{
  for (i = 1; i<=n; i++)
  {
    digitalWrite(pin_LED+notte,HIGH);
    delay(Il);
    digitalWrite(pin_LED+notte,LOW);
    delay(Ip);
  }
}
}

void trilla (int o) {
   for (int l = 0; l < 16;l++)  {

       playTone(random(1000)+500,30+random(40));
       delay(40+random(40));
       }
       delay(1500);
   for (int l = 1; l <= o;l++)  {
        playTone(500,100);
     delay(1000);
  }
}


void playTone(int tono, int duration) {
 
 for (long i = 0; i < duration * 1000L; i += tono * 2) {
    digitalWrite(speakerPin, HIGH);
    delayMicroseconds(tono);
    digitalWrite(speakerPin, LOW);
    delayMicroseconds(tono);
  } 
}
